diff --git a/freebsd/sys/sys/filedesc.h b/freebsd/sys/sys/filedesc.h
index a3224f42..dc132677 100644
--- a/freebsd/sys/sys/filedesc.h
+++ b/freebsd/sys/sys/filedesc.h
@@ -76,7 +76,6 @@ struct fdescenttbl {
  */
 #define NDSLOTTYPE	u_long
 
-#ifndef __rtems__
 struct filedesc {
 	struct	fdescenttbl *fd_files;	/* open files table */
 	struct	vnode *fd_cdir;		/* current directory */
@@ -93,9 +92,6 @@ struct filedesc {
 	int	fd_holdleaderscount;	/* block fdfree() for shared close() */
 	int	fd_holdleaderswakeup;	/* fdfree() needs wakeup */
 };
-#else /* __rtems__ */
-struct filedesc;
-#endif /* __rtems__ */
 
 /*
  * Structure to keep track of (process leader, struct fildedesc) tuples.
@@ -106,7 +102,6 @@ struct filedesc;
  *
  * fdl_refcount and fdl_holdcount are protected by struct filedesc mtx.
  */
-#ifndef __rtems__
 struct filedesc_to_leader {
 	int		fdl_refcount;	/* references from struct proc */
 	int		fdl_holdcount;	/* temporary hold during closef */
@@ -118,9 +113,6 @@ struct filedesc_to_leader {
 };
 #define	fd_nfiles	fd_files->fdt_nfiles
 #define	fd_ofiles	fd_files->fdt_ofiles
-#else /* __rtems__ */
-struct filedesc_to_leader;
-#endif /* __rtems__ */
 
 /*
  * Per-process open flags.
@@ -128,26 +120,15 @@ struct filedesc_to_leader;
 #define	UF_EXCLOSE	0x01		/* auto-close on exec */
 
 #ifdef _KERNEL
-#ifdef __rtems__
-#include <sys/file.h>
-#include <rtems/libio_.h>
-#endif /* __rtems__ */
 
 /* Lock a file descriptor table. */
 #define	FILEDESC_LOCK_INIT(fdp)	sx_init(&(fdp)->fd_sx, "filedesc structure")
 #define	FILEDESC_LOCK_DESTROY(fdp)	sx_destroy(&(fdp)->fd_sx)
 #define	FILEDESC_LOCK(fdp)	(&(fdp)->fd_sx)
-#ifndef __rtems__
 #define	FILEDESC_XLOCK(fdp)	sx_xlock(&(fdp)->fd_sx)
 #define	FILEDESC_XUNLOCK(fdp)	sx_xunlock(&(fdp)->fd_sx)
 #define	FILEDESC_SLOCK(fdp)	sx_slock(&(fdp)->fd_sx)
 #define	FILEDESC_SUNLOCK(fdp)	sx_sunlock(&(fdp)->fd_sx)
-#else /* __rtems__ */
-#define	FILEDESC_XLOCK(fdp)	do { } while (0)
-#define	FILEDESC_XUNLOCK(fdp)	do { } while (0)
-#define	FILEDESC_SLOCK(fdp)	do { } while (0)
-#define	FILEDESC_SUNLOCK(fdp)	do { } while (0)
-#endif /* __rtems__ */
 
 #define	FILEDESC_LOCK_ASSERT(fdp)	sx_assert(&(fdp)->fd_sx, SX_LOCKED | \
 					    SX_NOTRECURSED)
@@ -177,42 +158,13 @@ void	filecaps_init(struct filecaps *fcaps);
 bool	filecaps_copy(const struct filecaps *src, struct filecaps *dst,
 	    bool locked);
 void	filecaps_move(struct filecaps *src, struct filecaps *dst);
-#ifndef __rtems__
 void	filecaps_free(struct filecaps *fcaps);
-#else /* __rtems__ */
-#define	filecaps_free(fcaps) do { } while (0)
-#endif /* __rtems__ */
 
 int	closef(struct file *fp, struct thread *td);
 int	dupfdopen(struct thread *td, struct filedesc *fdp, int dfd, int mode,
 	    int openerror, int *indxp);
-#ifndef __rtems__
 int	falloc_caps(struct thread *td, struct file **resultfp, int *resultfd,
 	    int flags, struct filecaps *fcaps);
-#else /* __rtems__ */
-static inline int
-falloc_caps(struct thread *td, struct file **resultfp, int *resultfd,
-    int flags, struct filecaps *fcaps)
-{
-	rtems_libio_t *iop;
-
-	(void)td;
-	(void)flags;
-	(void)fcaps;
-
-	iop = rtems_libio_allocate();
-	*resultfp = rtems_bsd_iop_to_fp(iop);
-
-	if (iop != NULL) {
-		iop->pathinfo.mt_entry = &rtems_filesystem_null_mt_entry;
-		rtems_filesystem_location_add_to_mt_entry(&iop->pathinfo);
-		*resultfd = rtems_libio_iop_to_descriptor(iop);
-		return (0);
-	} else {
-		return (ENFILE);
-	}
-}
-#endif /* __rtems__ */
 int	falloc_noinstall(struct thread *td, struct file **resultfp);
 void	_finstall(struct filedesc *fdp, struct file *fp, int fd, int flags,
 	    struct filecaps *fcaps);
@@ -221,22 +173,7 @@ int	finstall(struct thread *td, struct file *fp, int *resultfd, int flags,
 int	fdalloc(struct thread *td, int minfd, int *result);
 int	fdallocn(struct thread *td, int minfd, int *fds, int n);
 int	fdcheckstd(struct thread *td);
-#ifndef __rtems__
 void	fdclose(struct thread *td, struct file *fp, int idx);
-#else /* __rtems__ */
-/*
- * WARNING: Use of fdrop() after fclose() corrupts the file descriptor.  See
- * fdrop() comment.
- */
-static inline void
-fdclose(struct thread *td, struct file *fp, int idx)
-{
-	(void)td;
-	(void)idx;
-
-	rtems_libio_free(&fp->f_io);
-}
-#endif /* __rtems__ */
 void	fdcloseexec(struct thread *td);
 void	fdsetugidsafety(struct thread *td);
 struct	filedesc *fdcopy(struct filedesc *fdp);
@@ -261,27 +198,9 @@ int	fget_cap(struct thread *td, int fd, cap_rights_t *needrightsp,
 	    struct file **fpp, struct filecaps *havecapsp);
 
 /* Return a referenced file from an unlocked descriptor. */
-#ifndef __rtems__
 int	fget_unlocked(struct filedesc *fdp, int fd, cap_rights_t *needrightsp,
 	    struct file **fpp, seq_t *seqp);
-#else /* __rtems__ */
-static inline int
-do_fget_unlocked(struct filedesc *fdp, int fd, struct file **fpp, seq_t *seqp)
-{
-	struct file *fp;
-
-	(void)fdp;
-	(void)seqp;
-	fp = rtems_bsd_get_file(fd);
-	*fpp = fp;
-	return (fp != NULL ? 0 : EBADF);
-}
 
-#define	fget_unlocked(fdp, fd, needrightsp, fpp, seqp) \
-    do_fget_unlocked(fdp, fd, fpp, seqp)
-#endif /* __rtems__ */
-
-#ifndef __rtems__
 /* Requires a FILEDESC_{S,X}LOCK held and returns without a ref. */
 static __inline struct file *
 fget_locked(struct filedesc *fdp, int fd)
@@ -320,13 +239,15 @@ fd_modified(struct filedesc *fdp, int fd, seq_t seq)
 	return (!seq_consistent(fd_seq(fdp->fd_files, fd), seq));
 }
 #endif
-#endif /* __rtems__ */
 
 /* cdir/rdir/jdir manipulation functions. */
 void	pwd_chdir(struct thread *td, struct vnode *vp);
 int	pwd_chroot(struct thread *td, struct vnode *vp);
 void	pwd_ensure_dirs(void);
 
+#ifdef __rtems__
+#include <machine/rtems-bsd-libio.h>
+#endif /* __rtems__ */
 #endif /* _KERNEL */
 
 #endif /* !_SYS_FILEDESC_H_ */
diff --git a/freebsd/sys/sys/jail.h b/freebsd/sys/sys/jail.h
index b772e91c..8168ff2c 100644
--- a/freebsd/sys/sys/jail.h
+++ b/freebsd/sys/sys/jail.h
@@ -399,7 +399,18 @@ getcredhostid(struct ucred *cred, unsigned long *hostid)
 }
 #endif /* __rtems__ */
 void prison0_init(void);
+#ifndef __rtems__
 int prison_allow(struct ucred *, unsigned);
+#else /* __rtems__ */
+static inline int
+prison_allow(struct ucred *cred1, unsigned i)
+{
+
+	(void)cred1;
+	(void)i;
+	return (0);
+}
+#endif /* __rtems__ */
 #ifndef __rtems__
 int prison_check(struct ucred *cred1, struct ucred *cred2);
 #else /* __rtems__ */
diff --git a/freebsd/sys/sys/mount.h b/freebsd/sys/sys/mount.h
index 698716f5..ed6eccd3 100644
--- a/freebsd/sys/sys/mount.h
+++ b/freebsd/sys/sys/mount.h
@@ -696,6 +696,7 @@ struct vfsops {
 
 vfs_statfs_t	__vfs_statfs;
 
+#ifndef __rtems__
 #define	VFS_PROLOGUE(MP)	do {					\
 	struct mount *mp__;						\
 	int _prev_stops;						\
@@ -708,6 +709,10 @@ vfs_statfs_t	__vfs_statfs;
 #define	VFS_EPILOGUE(MP)						\
 	sigallowstop(_prev_stops);					\
 } while (0)
+#else /* __rtems__ */
+#define	VFS_PROLOGUE(MP)
+#define	VFS_EPILOGUE(MP)
+#endif /* __rtems__ */
 
 #define	VFS_MOUNT(MP) ({						\
 	int _rc;							\
@@ -857,6 +862,7 @@ vfs_statfs_t	__vfs_statfs;
 #define VFS_VERSION_02	0x20180504
 #define VFS_VERSION	VFS_VERSION_02
 
+#ifndef __rtems__
 #define VFS_SET(vfsops, fsname, flags) \
 	static struct vfsconf fsname ## _vfsconf = {		\
 		.vfc_version = VFS_VERSION,			\
@@ -871,6 +877,22 @@ vfs_statfs_t	__vfs_statfs;
 		& fsname ## _vfsconf				\
 	};							\
 	DECLARE_MODULE(fsname, fsname ## _mod, SI_SUB_VFS, SI_ORDER_MIDDLE)
+#else /* __rtems__ */
+#define VFS_SET(vfsops, fsname, flags) \
+	struct vfsconf fsname ## _vfsconf = {			\
+		.vfc_version = VFS_VERSION,			\
+		.vfc_name = #fsname,				\
+		.vfc_vfsops = &vfsops,				\
+		.vfc_typenum = -1,				\
+		.vfc_flags = flags,				\
+	};							\
+	moduledata_t fsname ## _mod = {				\
+		#fsname,					\
+		vfs_modevent,					\
+		& fsname ## _vfsconf				\
+	};							\
+	DECLARE_MODULE(fsname, fsname ## _mod, SI_SUB_VFS, SI_ORDER_MIDDLE)
+#endif /* __rtems__ */
 
 /*
  * exported vnode operations
diff --git a/freebsd/sys/sys/proc.h b/freebsd/sys/sys/proc.h
index bb9e91ce..6ac1025d 100644
--- a/freebsd/sys/sys/proc.h
+++ b/freebsd/sys/sys/proc.h
@@ -718,7 +718,9 @@ struct proc {
 	int		p_osrel;	/* (x) osreldate for the
 					       binary (from ELF note, if any) */
 	char		p_comm[MAXCOMLEN + 1];	/* (x) Process name. */
+#endif /* __rtems__ */
 	struct sysentvec *p_sysent;	/* (b) Syscall dispatch info. */
+#ifndef __rtems__
 	struct pargs	*p_args;	/* (c) Process arguments. */
 	rlim_t		p_cpulimit;	/* (c) Current CPU limit in seconds. */
 	signed char	p_nice;		/* (c) Process "nice" value. */
diff --git a/freebsd/sys/sys/resourcevar.h b/freebsd/sys/sys/resourcevar.h
index 7c7e8458..ea038887 100644
--- a/freebsd/sys/sys/resourcevar.h
+++ b/freebsd/sys/sys/resourcevar.h
@@ -123,7 +123,7 @@ void	 calcru(struct proc *p, struct timeval *up, struct timeval *sp);
 #ifndef __rtems__
 int	 chgkqcnt(struct uidinfo *uip, int diff, rlim_t max);
 #else /* __rtems__ */
-#define	 chgkqcnt(uip, diff, max) 0
+#define	 chgkqcnt(uip, diff, max) 1
 #endif /* __rtems__ */
 int	 chgproccnt(struct uidinfo *uip, int diff, rlim_t maxval);
 #ifndef __rtems__
@@ -146,7 +146,14 @@ int	 kern_proc_setrlimit(struct thread *td, struct proc *p, u_int which,
 struct plimit
 	*lim_alloc(void);
 void	 lim_copy(struct plimit *dst, struct plimit *src);
+#ifndef __rtems__
 rlim_t	 lim_cur(struct thread *td, int which);
+#else /* __rtems__ */
+static inline rlim_t  lim_cur(struct thread *td, int which)
+{
+	return INT64_MAX;
+}
+#endif /* __rtems__ */
 rlim_t	 lim_cur_proc(struct proc *p, int which);
 void	 lim_fork(struct proc *p1, struct proc *p2);
 void	 lim_free(struct plimit *limp);
diff --git a/freebsd/sys/sys/sysctl.h b/freebsd/sys/sys/sysctl.h
index c21f19d3..fa9779f3 100644
--- a/freebsd/sys/sys/sysctl.h
+++ b/freebsd/sys/sys/sysctl.h
@@ -1129,18 +1129,10 @@ int	sysctl_ctx_entry_del(struct sysctl_ctx_list *clist,
 	    struct sysctl_oid *oidp);
 
 int	kernel_sysctl(struct thread *td, int *name, u_int namelen, void *old,
-#ifndef __rtems__
 	    size_t *oldlenp, void *new, size_t newlen, size_t *retval,
-#else /* __rtems__ */
-	    size_t *oldlenp, const void *newp, size_t newlen, size_t *retval,
-#endif /* __rtems__ */
 	    int flags);
 int	kernel_sysctlbyname(struct thread *td, char *name, void *old,
-#ifndef __rtems__
 	    size_t *oldlenp, void *new, size_t newlen, size_t *retval,
-#else /* __rtems__ */
-	    size_t *oldlenp, const void *newp, size_t newlen, size_t *retval,
-#endif /* __rtems__ */
 	    int flags);
 #ifndef __rtems__
 int	userland_sysctl(struct thread *td, int *name, u_int namelen, void *old,
diff --git a/freebsd/sys/sys/sysent.h b/freebsd/sys/sys/sysent.h
index d1d9e99b..2a2e63a1 100644
--- a/freebsd/sys/sys/sysent.h
+++ b/freebsd/sys/sys/sysent.h
@@ -93,6 +93,7 @@ struct trapframe;
 struct vnode;
 
 struct sysentvec {
+#ifndef __rtems__
 	int		sv_size;	/* number of entries */
 	struct sysent	*sv_table;	/* pointer to sysent */
 	u_int		sv_mask;	/* optional mask to index */
@@ -123,7 +124,9 @@ struct sysentvec {
 			    u_long);
 	void		(*sv_fixlimit)(struct rlimit *, int);
 	u_long		*sv_maxssiz;
+#endif /* __rtems__ */
 	u_int		sv_flags;
+#ifndef __rtems__
 	void		(*sv_set_syscall_retval)(struct thread *, int);
 	int		(*sv_fetch_syscall_args)(struct thread *);
 	const char	**sv_syscallnames;
@@ -137,6 +140,7 @@ struct sysentvec {
 	int		(*sv_trap)(struct thread *);
 	u_long		*sv_hwcap;	/* Value passed in AT_HWCAP. */
 	u_long		*sv_hwcap2;	/* Value passed in AT_HWCAP2. */
+#endif /* __rtems__ */
 };
 
 #define	SV_ILP32	0x000100	/* 32-bit executable. */
